/**
  * @file fls_nor_flash.c
  * @author generated by mrt-device utility 
  * @link [https://github.com/uprev-mrt/mrtutils/wiki/mrt-device]
  * @brief Device driver for fls_nor_flash device
  *
  */


/* Includes ------------------------------------------------------------------*/
#include "fls_nor_flash.h"

/*user-block-top-start*/
/* Private Variables ---------------------------------------------------------*/
/* Private Functions ---------------------------------------------------------*/

mrt_status_t fls_regdev_read_spi(mrt_regdev_t* dev, uint32_t addr, uint8_t* data, int len);
mrt_status_t fls_regdev_write_spi(mrt_regdev_t* dev, uint32_t addr, uint8_t* data, int len);

/*user-block-top-end*/


/**
 * @brief initializes device
 * @param dev ptr to fls_nor_flash device
 * @return status 
 */
static mrt_status_t fls_init(fls_nor_flash_t* dev)
{   
    /* Initialize Register Descriptors */
    REG_INIT( dev->mStatus , FLS_REG_STATUS_ADDR , uint8_t, REG_PERM_R , 0x00  );
    REG_INIT( dev->mConfig , FLS_REG_CONFIG_ADDR , uint8_t, REG_PERM_R , 0x00  );
    REG_INIT( dev->mBankAddr , FLS_REG_BANK_ADDR_ADDR , uint8_t, REG_PERM_R , 0x00  );
    REG_INIT( dev->mSecErase , FLS_REG_SEC_ERASE_ADDR , uint8_t, REG_PERM_W , 0x00  );
    REG_INIT( dev->mBulkErase , FLS_REG_BULK_ERASE_ADDR , uint8_t, REG_PERM_W , 0x00  );
    REG_INIT( dev->mProgData , FLS_REG_PROG_DATA_ADDR , uint8_t, REG_PERM_W , 0x00  );
    REG_INIT( dev->mReadData , FLS_REG_READ_DATA_ADDR , uint8_t, REG_PERM_R , 0x00  );


    /*user-block-init-start*/
    /*user-block-init-end*/

    return MRT_STATUS_OK;
}


mrt_status_t fls_init_spi(fls_nor_flash_t* dev, mrt_spi_handle_t spi, mrt_gpio_t chipSelect)
{
    mrt_status_t status;

    status = init_spi_register_device(&dev->mRegDev, spi, chipSelect, FLS_NOR_FLASH_REG_ADDR_SIZE );

    fls_init(dev);

    /*user-block-spi-start*/
    dev->mRegDev.read = fls_regdev_read_spi;
    dev->mRegDev.write = fls_regdev_write_spi;
    /*user-block-spi-end*/

    return status;
}

mrt_status_t fls_test(fls_nor_flash_t* dev)
{
    mrt_status_t status = MRT_STATUS_ERROR;
    /*user-block-test-start*/

    /*user-block-test-end*/
    return status;
}


/*user-block-bottom-start*/


mrt_status_t fls_regdev_read_spi(mrt_regdev_t* dev, uint32_t addr, uint8_t* data, int len)
{
    return MRT_STATUS_OK;
}

mrt_status_t fls_regdev_write_spi(mrt_regdev_t* dev, uint32_t addr, uint8_t* data, int len)
{
    return MRT_STATUS_OK;
}
/*user-block-bottom-end*/
